#ifndef FIND_COM_PORTS_H
#define FIND_COM_PORTS_H

/*!
  \file
  \brief COM |[gꗗ̎擾

  \author Satofumi KAMIMURA

  $Id: FindComPorts.h 486 2009-01-20 14:19:23Z satofumi $

  \attention mF Windows XP ̂݁Bł͖
*/

#include <string>
#include <vector>
#include <memory>


namespace qrk
{
  class IsUsbCom;

  /*!
    \brief VA|[g̒Ts

    Windows ł́AWXg COM ꗗ擾ĕԂB\n
    Linux, MacOS ł́A^ꂽp^[Ɉvt@C擾ĕԂB
  */
  class FindComPorts
  {
    FindComPorts(const FindComPorts& rhs);
    FindComPorts& operator = (const FindComPorts& rhs);

    struct pImpl;
    std::auto_ptr<pImpl> pimpl;

  public:
    FindComPorts(IsUsbCom* is_usb = NULL);
    ~FindComPorts(void);

    void clear(void);
    void addBaseName(const char* base_name);
    std::vector<std::string> baseNames(void);

    /*!
      \brief COM |[gꗗ̎擾

      \retval COM ꗗi[ꂽ string z
    */
    std::vector<std::string> find(void);
  };
}

#endif /* !FIND_COM_PORTS_H */
